#!/usr/bin/env node
import { CUSTOM_TEMPLATE_NAME as w } from "./utils/const.mjs";
import { projectNameForm as E, templateForm as S, templateChoices as x, saveGitHistoryForm as h } from "./utils/question.mjs";
import n from "prompts";
import { execSync as a } from "node:child_process";
import { existsSync as l, rmSync as i, readFileSync as p, writeFileSync as g } from "node:fs";
import { resolve as k } from "node:path";
import r from "chalk";
const I = async (u) => {
  const {
    projectName: f,
    template: d,
    saveGitHistory: y
  } = u, t = ((f ?? (await n(E)).projectName) || "").trim();
  if (!t.trim()) {
    console.log(r.red("项目名称不能为空"));
    return;
  }
  if (t.includes(" ") || t.includes("\\") || t.includes("/")) {
    console.log(r.red("项目名称不能包含空格或者\\或者/"));
    return;
  }
  const e = k(process.cwd(), t);
  if (l(e)) {
    const { isRemove: o } = await n({
      type: "confirm",
      name: "isRemove",
      message: "项目已存在，是否删除"
    });
    if (o === !0)
      i(e, { recursive: !0, force: !0 });
    else
      return console.log(r.red("项目已存在")), process.exit(1);
  }
  const s = d ?? (await n(S)).template;
  let c = "";
  if (s === w) {
    const { customUrl: o } = await n({
      type: "text",
      name: "customUrl",
      message: "请输入自定义模板路径"
    });
    c = o;
  } else {
    const o = x.find((j) => j.name === s);
    if (!o)
      return console.log(r.red(`模板${s}不存在`)), process.exit(1);
    if (!o.url)
      return console.log(r.red(`模板${s}仓库地址不存在`)), process.exit(1);
    c = o.url;
  }
  if (console.log(r.green("正在初始化项目，请稍等...")), a(`git clone ${c} ${t} --depth=1`), (y ?? (await n(h)).saveGitHistory) === !1) {
    const o = `${e}/.git`;
    if (!l(o))
      throw new Error("git目录不存在");
    i(`${e}/.git`, { recursive: !0, force: !0 });
  } else
    a(`cd ${e} && git remote rename origin upstream`);
  const $ = p(`${e}/package.json`, "utf-8"), m = JSON.parse($), { name: v } = m;
  m.name = t, i(`${e}/package.json`), g(
    `${e}/package.json`,
    JSON.stringify(m, null, 2)
  );
  const N = p(`${e}/README.md`, "utf-8").replace(v, t);
  i(`${e}/README.md`), g(`${e}/README.md`, N), console.log(r.green("项目初始化完成")), console.log(
    r.blue(`
使用步骤: 
  1. cd ${t}
  2. pnpm install
  3. pnpm run dev
  `)
  );
};
export {
  I as handler
};
